import java.util.Iterator;


public class InsiemeLimitato 
       implements Iterable<Integer> {
	private final int[] elementi;
	private int numElementi;
	
	public InsiemeLimitato(int n){
		numElementi=0;
		elementi = new int[n];
	}
	
	public int getNumElementi(){
		return numElementi;
	}
	
	public int getSize(){
		return elementi.length;
	}
	
	public boolean contenuto (int e){
		for (int i=0; i<numElementi; i++){
			if (e==elementi[i]){
				return true;
			}
		}
		return false;
	}

	public boolean vuoto(){
		return numElementi==0;
	}
	
	public boolean pieno (){
		return numElementi==getSize();
	}
	
	public void add(int e){
		if (pieno()) {
			throw new EccezioneInsiemeLimitato
			           ("Insieme pieno");
		}
		if (contenuto(e)) return;
		elementi[numElementi]=e;
		numElementi++;
	}
	
	public int get (int pos){
		if (pos<0 || pos>=numElementi){
			throw new EccezioneInsiemeLimitato
			           ("Indice non valido");
		}
		return elementi[pos];
	}

	@Override
	public Iterator<Integer> iterator() {
		// TODO Auto-generated method stub
		return new IteratoreInsiemeLimitato(this);
	}
	
}
